
package de.ivu.elect.presentation.gebietsbaum.exchange;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.exchange.control.AbstractImporter;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsgruppierungImporter;
import de.ivu.elect.business.gebietsbaum.control.GebietsgruppierungImportContext;
import de.ivu.elect.business.gebietsbaum.entity.Gebietsgruppierung;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractImportBestaetigenView;
import de.ivu.elect.presentation.exchange.ImportDescription;

@Named(GebietsgruppierungImportBestaetigenView.COMPONENT_NAME)
@View(viewId = GebietsgruppierungImportBestaetigenView.VIEW_ID, useCase = UseCasePermission.GEBIETSGRUPPIERUNG_IMPORTIEREN)
public class GebietsgruppierungImportBestaetigenView
    extends
      AbstractImportBestaetigenView<List<Gebietsgruppierung>, GebietsgruppierungImportContext> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietsgruppierungImportBestaetigenView";

  public static final String VIEW_ID = "/gebietsbaum/gebietsgruppierung-import-bestaetigen.xhtml";

  @Inject
  private transient GebietsgruppierungImporter importer;

  @Inject
  private transient GebietsgruppierungImportDescription importDescription;

  public GebietsgruppierungImportBestaetigenView() {
    super();
  }

  @Override
  protected AbstractImporter<List<Gebietsgruppierung>, GebietsgruppierungImportContext, ? > getImporter() {
    return importer;
  }

  @Override
  protected GebietsgruppierungImportContext getContext() {
    if (isWahlSelected()) {
      return new GebietsgruppierungImportContext(getSelectedWahl());
    }

    return new GebietsgruppierungImportContext(getSelectedWahltermin());
  }

  @Override
  protected ImportDescription getImportDescription() {
    return importDescription;
  }

}
